#include <stdio.h>
#include <stdlib.h>
#include   <dos.h>
#include <conio.h>
#include <string.h>
#include <dir.h>
#include <io.h>


/* Define constants for pre-processor */
#define CORNER_TL  0xc9
#define CORNER_TR  0xbb
#define CORNER_BL  0xc8
#define CORNER_BR  0xbc
#define HORIZ_LINE  0xcd
#define VERT_LINE  0xba
#define ALT_P 25
#define ALT_C 46
#define ALT_R 19
#define ALT_A 30
#define ALT_Q 16
#define ALWAYS 1
#define DOWNARROW 0x50
#define UPARROW 0x48
#define RETURN 0xd
#define ESCAPE 0x1b
#define RETURN 0xd


/* FUNCTION DECLARATIONS */

/* Routines involved in actually reading and writing to PROMs:
located in file PROM_IO.CPP */
	extern void prom_write (void);
	extern unsigned char read_byte (void);
	extern void manual_read (void);
	extern void read_tofile (void);
	extern void compare (void);

/* Routines involved in fetching user input: located in file INPUT.CPP.
 The "get..." functions fetch user input for the relevant variables. The rest
 are generic routines used by the "get..." functions and others. */
	extern void getread_variables (void);
	extern void getcompare_variables (void);
	extern void getprogram_variables (int);
	extern void text_input (char *, int, int);
	extern unsigned long longint_input (char *, int, int);
	extern float float_input (char *, int, int);
	extern int input_yn (void);
	extern void custom_bytes (int);
	extern char input_0_1 (int);

/* Utility and miscellaneous functions: located in file UTILITY.CPP */
	extern void get_dftfile (void);
	extern void write_dftfile (void);
	extern int c_break (void);
	extern void t_constant (void);
	extern int is_stringchar (char);
	extern int is_hexvalue (char);
	extern int is_digit (char);
	extern unsigned long hex_convert (char *);

/* Screen painting routines: located in file SCRN_OUT.CPP
These include routines for printing prompts: " _prompts"
and input fields: "_infields".  There is no separate screen
routine for the "address peek" menu item as this one only uses the
status window on the screen for input and output and all screen writing
is handled within the actual functional code module. */
	extern void paint_window (void);
	extern void clear_window (int, int);
	extern void compare_prompts (void);
	extern void program_prompts (void);
	extern void read_prompts (void);
	extern void menu_topics (void);
	extern void compare_infields (void);
	extern void program_infields (int);
	extern void show_device_selection (int, int);
	extern void read_infields (void);

/* Assembly language routine: source in T_LOOP.ASM; object file in *.OBJ */
	extern "C" {void timer (unsigned long);}


/* GLOBAL VARIABLE DECLARATIONS */

/* Programming and PROM read numerical variables */
	extern unsigned long start_byte, num_byte, start_addr, wrpulse_num, j_millisec;
	extern float final_pulse, pulse_len;
	extern int device_option;

/* ASCII string versions of variables (as input by user) */
	extern char in_fl_name[70], out_fl_name[70];
	extern char sstart_byte[20], snum_byte[20], sstart_addr[20];
	extern char swrpulse_num[20], spulse_len[20], sfinal_pulse[20];

/* Other internal use variables eg programmer control bytes */
	extern unsigned char bdata[16384], write_byte;
	extern unsigned char verify_byte, standby_a, standby_b;
	extern unsigned long twaste;

/* Screen color attribute variables */
	extern int main_screen;
	extern int menu_title;
	extern int active_prompts;
	extern int active_input;
	extern int status_window;
	extern int status_window_perm;

/* Miscellaneous */
	extern int exit_code;
	extern unsigned port_out, port_in, port_control;

